diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/examples/three-gpp-channel-example.cc ns-3.47/src/spectrum/examples/three-gpp-channel-example.cc
--- ns-3.46/src/spectrum/examples/three-gpp-channel-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/examples/three-gpp-channel-example.cc	2026-02-16 16:08:49.821230600 -0800
@@ -6,25 +6,30 @@
  */
 
 /**
+ * @file
  * This example shows how to configure the 3GPP channel model classes to
  * compute the SNR between two nodes.
  * The simulation involves two static nodes which are placed at a certain
- * distance from each other and communicates through a wireless channel at
+ * distance from each other and communicate through a wireless channel at
  * 2 GHz with a bandwidth of 18 MHz. The default propagation environment is
- * 3D-urban macro (UMa) and it can be configured changing the value of the
+ * 3D-urban macro (UMa), and it can be configured changing the value of the
  * string "scenario".
- * Each node hosts a SimpleNetDevice and has an antenna array with 4 elements.
+ * Each node hosts has an antenna array with 4 antenna elements.
+ *
+ * The example writes its main results to the file ``snr-trace.txt``.
+ * Each row contains: (i) the simulation time (s), (ii) the SNR obtained with
+ * steering vectors (``DoBeamforming``), (iii) the SNR obtained with matched-filter
+ * combining, and (iv) the propagation gain.
  */
 
 #include "ns3/channel-condition-model.h"
 #include "ns3/constant-position-mobility-model.h"
+#include "ns3/constant-velocity-mobility-model.h"
 #include "ns3/core-module.h"
 #include "ns3/lte-spectrum-value-helper.h"
 #include "ns3/mobility-model.h"
-#include "ns3/net-device.h"
 #include "ns3/node-container.h"
 #include "ns3/node.h"
-#include "ns3/simple-net-device.h"
 #include "ns3/spectrum-signal-parameters.h"
 #include "ns3/three-gpp-channel-model.h"
 #include "ns3/three-gpp-propagation-loss-model.h"
@@ -58,19 +63,63 @@
 };
 
 /**
- * Perform the beamforming using the DFT beamforming method
- * @param thisDevice the device performing the beamforming
- * @param thisAntenna the antenna object associated to thisDevice
- * @param otherDevice the device towards which point the beam
+ * Perform a simple (DFT/steering) beamforming toward the other node.
+ *
+ * This function builds a per-element complex weight vector based on the geometric
+ * direction between two nodes and the antenna element locations returned by
+ * `PhasedArrayModel::GetElementLocation()`. The weights are unit-norm (equal
+ * power across elements) and have the form:
+ *
+ *   w[i] = exp(j * phase_i) / sqrt(N),
+ *   phase_i = sign * 2*pi * ( u · r_i )
+ *
+ * where `u` is the unit direction corresponding to the azimuth/inclination
+ * angles of the line-of-sight vector between the nodes, `r_i` is the location of
+ * element `i` in the array coordinate system, and `N` is the number of antenna
+ * elements.
+ *
+ * Sign convention and how to use this function:
+ *
+ * The 3GPP channel coefficients are constructed using spatial phase terms of the
+ * form exp(+j*2*pi*(u·r)) (see `ThreeGppChannelModel::GetNewChannel()`), i.e., the
+ * array *response/steering vector* toward a direction is proportional to:
+ *
+ *   a(theta)[i] = exp(+j*2*pi*(u·r_i)).
+ *
+ * In standard array processing, a transmit precoder that steers energy toward
+ * that direction uses the complex conjugate of the response, therefore
+ * sign = -1  (phase = -2*pi*(u·r_i)).
+ *
+ * For receive combining, the effective scalar channel is computed using the
+ * Hermitian inner product:
+ *
+ *   h_eff = w_rx^H * H * w_tx .
+ *
+ * To obtain matched-filter (maximum-ratio) receive combining toward the same
+ * direction, the stored receive weight vector should be proportional to the
+ * response a(theta), so that `w_rx^H` applies the conjugation at combining time
+ * sign = +1  (phase = +2*pi*(u·r_i)).
+ *
+ * Therefore, when this function is used to set beamforming vectors explicitly in
+ * this example:
+ *   - Use `sign = -1` when generating TX weights (precoding).
+ *   - Use `sign = +1` when generating RX weights (so that Hermitian combining
+ *     applies the conjugation).
+ *
+ * @param txMob The mobility model of the node for which the weights are generated.
+ * @param thisAntenna The antenna array on which the beamforming vector is set.
+ * @param rxMob The mobility model of the peer node toward/from which the beam is steered.
+ * @param sign Phase progression sign: typically -1 for TX weights and +1 for RX weights.
  */
 static void
-DoBeamforming(Ptr<NetDevice> thisDevice,
+DoBeamforming(Ptr<MobilityModel> txMob,
               Ptr<PhasedArrayModel> thisAntenna,
-              Ptr<NetDevice> otherDevice)
+              Ptr<MobilityModel> rxMob,
+              double sign)
 {
-    // retrieve the position of the two devices
-    Vector aPos = thisDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
-    Vector bPos = otherDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
+    // retrieve the position of the two nodes
+    Vector aPos = txMob->GetPosition();
+    Vector bPos = rxMob->GetPosition();
 
     // compute the azimuth and the elevation angles
     Angles completeAngle(bPos, aPos);
@@ -94,7 +143,7 @@
     for (uint64_t ind = 0; ind < totNoArrayElements; ind++)
     {
         Vector loc = thisAntenna->GetElementLocation(ind);
-        double phase = -2 * M_PI *
+        double phase = sign * 2 * M_PI *
                        (sinVAngleRadian * cosHAngleRadian * loc.x +
                         sinVAngleRadian * sinHAngleRadian * loc.y + cosVAngleRadian * loc.z);
         antennaWeights[ind] = exp(std::complex<double>(0, phase)) * power;
@@ -105,6 +154,76 @@
 }
 
 /**
+ * Build the RX matched-filter (maximum-ratio) combining vector by aggregating
+ * the contributions of all clusters and normalizing the result:
+ * \f[
+ * \mathbf{g} = \sum_{c} \mathbf{H}_{c}\mathbf{w}_{\rm tx}, \qquad
+ * \mathbf{w}_{\rm rx} = \frac{\mathbf{g}}{\|\mathbf{g}\|}
+ * \f]
+ *
+ * The per-cluster channel matrix \f$\mathbf{H}_{c}\f$ is obtained from
+ * ``params->m_channel(u, s, c)`` (u: RX element index, s: TX element index, c: cluster index).
+ *
+ * @param params Channel parameters containing the per-cluster channel matrix.
+ * @param txAntenna TX phased-array model.
+ * @param rxAntenna RX phased-array model.
+ * @param wTx Unit-norm TX beamforming/precoding vector (size must match
+ * ``txAntenna->GetNumElems()``).
+ *
+ * @return The RX combining vector (size ``rxAntenna->GetNumElems()``), normalized to unit norm
+ *         (unless the channel is all-zero, in which case a zero vector is returned).
+ */
+
+static ns3::PhasedArrayModel::ComplexVector
+BuildRxMatchedFilterOverAllClusters(
+    ns3::Ptr<const ns3::MatrixBasedChannelModel::ChannelMatrix> params,
+    ns3::Ptr<const ns3::PhasedArrayModel> txAntenna,
+    ns3::Ptr<const ns3::PhasedArrayModel> rxAntenna,
+    const ns3::PhasedArrayModel::ComplexVector& wTx)
+{
+    using C = std::complex<double>;
+
+    const uint64_t nTx = txAntenna->GetNumElems();
+    const uint64_t nRx = rxAntenna->GetNumElems();
+    const size_t numClusters = params->m_channel.GetNumPages();
+
+    NS_ASSERT_MSG(wTx.GetSize() == nTx, "wTx size does not match TX antenna elements");
+    NS_ASSERT_MSG(params->m_channel.GetNumRows() == nRx, "Channel rows != #RX elements");
+    NS_ASSERT_MSG(params->m_channel.GetNumCols() == nTx, "Channel cols != #TX elements");
+
+    ns3::PhasedArrayModel::ComplexVector g(nRx);
+
+    // g = sum_c (H_c * wTx)
+    for (size_t c = 0; c < numClusters; ++c)
+    {
+        for (uint64_t u = 0; u < nRx; ++u)
+        {
+            C acc{0.0, 0.0};
+            for (uint64_t s = 0; s < nTx; ++s)
+            {
+                acc += params->m_channel(u, s, c) * wTx[s];
+            }
+            g[u] += acc;
+        }
+    }
+    // Normalize: wRx = g / ||g||
+    double norm2 = 0.0;
+    for (uint64_t u = 0; u < nRx; ++u)
+    {
+        norm2 += std::norm(g[u]);
+    }
+    if (norm2 > 0.0)
+    {
+        const double invNorm = 1.0 / std::sqrt(norm2);
+        for (uint64_t u = 0; u < nRx; ++u)
+        {
+            g[u] *= invNorm;
+        }
+    }
+    return g; // unit-norm (unless channel is all-zero)
+}
+
+/**
  * Compute the average SNR
  * @param params A structure that holds the parameters that are needed to perform calculations in
  * ComputeSnr
@@ -140,22 +259,49 @@
     NS_ASSERT_MSG(params.txAntenna, "params.txAntenna is nullptr!");
     NS_ASSERT_MSG(params.rxAntenna, "params.rxAntenna is nullptr!");
 
+    // set/update the beamforming vectors on each call
+    double sign = -1.0;
+    DoBeamforming(params.txMob, params.txAntenna, params.rxMob, sign);
+    sign = +1.0;
+    DoBeamforming(params.rxMob, params.rxAntenna, params.txMob, sign);
     // apply the fast fading and the beamforming gain
     auto rxParams = m_spectrumLossModel->CalcRxPowerSpectralDensity(txParams,
                                                                     params.txMob,
                                                                     params.rxMob,
                                                                     params.txAntenna,
                                                                     params.rxAntenna);
-    auto rxPsd = rxParams->psd;
-    NS_LOG_DEBUG("Average rx power " << 10 * log10(Sum(*rxPsd) * 180e3) << " dB");
-
-    // compute the SNR
-    NS_LOG_DEBUG("Average SNR " << 10 * log10(Sum(*rxPsd) / Sum(*noisePsd)) << " dB");
+    auto rxPsdSteering = rxParams->psd;
+    NS_LOG_DEBUG("Average rx power " << 10 * log10(Sum(*rxPsdSteering) * 180e3) << " dB");
+    NS_LOG_DEBUG("Average SNR " << 10 * log10(Sum(*rxPsdSteering) / Sum(*noisePsd)) << " dB");
+
+    Ptr<ThreeGppChannelModel> channelModel =
+        DynamicCast<ThreeGppChannelModel>(m_spectrumLossModel->GetChannelModel());
+    Ptr<const ThreeGppChannelModel::ChannelMatrix> channelMatrix =
+        channelModel->GetChannel(params.txMob, params.rxMob, params.txAntenna, params.rxAntenna);
+
+    const auto& wTx = params.txAntenna->GetBeamformingVectorRef();
+    auto wRx =
+        BuildRxMatchedFilterOverAllClusters(channelMatrix, params.txAntenna, params.rxAntenna, wTx);
+    params.rxAntenna->SetBeamformingVector(wRx); // Install RX matched-filter (MRC) combiner
+
+    auto rxParamsMatchedFilterComb =
+        m_spectrumLossModel->CalcRxPowerSpectralDensity(txParams,
+                                                        params.txMob,
+                                                        params.rxMob,
+                                                        params.txAntenna,
+                                                        params.rxAntenna);
+
+    auto rxPsdMatchedFilterComb = rxParamsMatchedFilterComb->psd;
+    NS_LOG_DEBUG("Average rx power when using matched filter combining "
+                 << 10 * log10(Sum(*rxPsdMatchedFilterComb) * 180e3) << " dB");
+    NS_LOG_DEBUG("Average SNR when using matched filter combining "
+                 << 10 * log10(Sum(*rxPsdMatchedFilterComb) / Sum(*noisePsd)) << " dB");
 
     // print the SNR and pathloss values in the snr-trace.txt file
     std::ofstream f;
     f.open("snr-trace.txt", std::ios::out | std::ios::app);
-    f << Simulator::Now().GetSeconds() << " " << 10 * log10(Sum(*rxPsd) / Sum(*noisePsd)) << " "
+    f << Simulator::Now().GetSeconds() << " " << 10 * log10(Sum(*rxPsdSteering) / Sum(*noisePsd))
+      << " " << 10 * log10(Sum(*rxPsdMatchedFilterComb) / Sum(*noisePsd)) << " "
       << propagationGainDb << std::endl;
     f.close();
 }
@@ -171,6 +317,16 @@
     uint32_t timeRes = 10;        // time resolution in milliseconds
     std::string scenario = "UMa"; // 3GPP propagation scenario
 
+    CommandLine cmd(__FILE__);
+    cmd.AddValue("frequency", "Operating frequency in Hz", frequency);
+    cmd.AddValue("txPow", "TX power in dBm", txPow);
+    cmd.AddValue("noiseFigure", "Noise figure in dB", noiseFigure);
+    cmd.AddValue("distance", "Distance between TX and RX nodes in meters", distance);
+    cmd.AddValue("simTime", "Simulation time in milliseconds", simTime);
+    cmd.AddValue("timeRes", "Time resolution in milliseconds", timeRes);
+    cmd.AddValue("scenario", "3GPP propagation scenario", scenario);
+    cmd.Parse(argc, argv);
+
     Config::SetDefault("ns3::ThreeGppChannelModel::UpdatePeriod",
                        TimeValue(MilliSeconds(1))); // update the channel at each iteration
     Config::SetDefault("ns3::ThreeGppChannelConditionModel::UpdatePeriod",
@@ -239,21 +395,12 @@
     NodeContainer nodes;
     nodes.Create(2);
 
-    // create the tx and rx devices
-    Ptr<SimpleNetDevice> txDev = CreateObject<SimpleNetDevice>();
-    Ptr<SimpleNetDevice> rxDev = CreateObject<SimpleNetDevice>();
-
-    // associate the nodes and the devices
-    nodes.Get(0)->AddDevice(txDev);
-    txDev->SetNode(nodes.Get(0));
-    nodes.Get(1)->AddDevice(rxDev);
-    rxDev->SetNode(nodes.Get(1));
-
     // create the tx and rx mobility models, set the positions
     Ptr<MobilityModel> txMob = CreateObject<ConstantPositionMobilityModel>();
     txMob->SetPosition(Vector(0.0, 0.0, 10.0));
-    Ptr<MobilityModel> rxMob = CreateObject<ConstantPositionMobilityModel>();
+    Ptr<ConstantVelocityMobilityModel> rxMob = CreateObject<ConstantVelocityMobilityModel>();
     rxMob->SetPosition(Vector(distance, 0.0, 1.6));
+    rxMob->SetVelocity(Vector(0.5, 0, 0)); // set small velocity to allow for channel updates
 
     // assign the mobility models to the nodes
     nodes.Get(0)->AggregateObject(txMob);
@@ -271,10 +418,6 @@
                                                        "NumRows",
                                                        UintegerValue(2));
 
-    // set the beamforming vectors
-    DoBeamforming(txDev, txAntenna, rxDev);
-    DoBeamforming(rxDev, rxAntenna, txDev);
-
     for (int i = 0; i < floor(simTime / timeRes); i++)
     {
         ComputeSnrParams params{txMob, rxMob, txPow, noiseFigure, txAntenna, rxAntenna};
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/examples/three-gpp-ntn-channel-example.cc ns-3.47/src/spectrum/examples/three-gpp-ntn-channel-example.cc
--- ns-3.46/src/spectrum/examples/three-gpp-ntn-channel-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/examples/three-gpp-ntn-channel-example.cc	2026-02-16 16:08:49.821230600 -0800
@@ -12,7 +12,7 @@
  * Specifically, most changes (which are also highlighted throughout the code)
  * impact the main method, and comprise:
  * - the configuration of ad-hoc propagation and channel condition models;
- * - the use of GeocentricConstantPositionMobilityModel for the nodes mobility.
+ * - the use of GeocentricConstantPositionMobilityModel for the nodes' mobility.
  * The pre-configured parameters are the one provided by 3GPP in TR 38.821,
  * more specifically scenario 10 in down-link mode.
  * Two static nodes, one on the ground and one in orbit, communicate with each other.
@@ -21,17 +21,12 @@
  */
 
 #include "ns3/antenna-model.h"
-#include "ns3/channel-condition-model.h"
-#include "ns3/constant-position-mobility-model.h"
 #include "ns3/core-module.h"
 #include "ns3/geocentric-constant-position-mobility-model.h"
 #include "ns3/isotropic-antenna-model.h"
 #include "ns3/mobility-model.h"
-#include "ns3/net-device.h"
 #include "ns3/node-container.h"
 #include "ns3/node.h"
-#include "ns3/parabolic-antenna-model.h"
-#include "ns3/simple-net-device.h"
 #include "ns3/spectrum-signal-parameters.h"
 #include "ns3/three-gpp-channel-model.h"
 #include "ns3/three-gpp-propagation-loss-model.h"
@@ -195,21 +190,15 @@
 
 /**
  * Perform the beamforming using the DFT beamforming method
- * @param thisDevice the device performing the beamforming
- * @param thisAntenna the antenna object associated to thisDevice
- * @param otherDevice the device towards which point the beam
+ * @param txMob the mobility model of the node performing the beamforming
+ * @param thisAntenna the antenna object associated to txMob
+ * @param rxMob the mobility model of the node towards which will point the beam
  */
 static void
-DoBeamforming(Ptr<NetDevice> thisDevice,
-              Ptr<PhasedArrayModel> thisAntenna,
-              Ptr<NetDevice> otherDevice)
+DoBeamforming(Ptr<MobilityModel> rxMob, Ptr<PhasedArrayModel> thisAntenna, Ptr<MobilityModel> txMob)
 {
-    // retrieve the position of the two devices
-    Vector aPos = thisDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
-    Vector bPos = otherDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
-
     // compute the azimuth and the elevation angles
-    Angles completeAngle(bPos, aPos);
+    Angles completeAngle(txMob->GetPosition(), rxMob->GetPosition());
     double hAngleRadian = completeAngle.GetAzimuth();
     double vAngleRadian = completeAngle.GetInclination(); // the elevation angle
 
@@ -405,16 +394,6 @@
     NodeContainer nodes;
     nodes.Create(2);
 
-    // create the tx and rx devices
-    Ptr<SimpleNetDevice> txDev = CreateObject<SimpleNetDevice>();
-    Ptr<SimpleNetDevice> rxDev = CreateObject<SimpleNetDevice>();
-
-    // associate the nodes and the devices
-    nodes.Get(0)->AddDevice(txDev);
-    txDev->SetNode(nodes.Get(0));
-    nodes.Get(1)->AddDevice(rxDev);
-    rxDev->SetNode(nodes.Get(1));
-
     // Start changes with respect to three-gpp-channel-example, here a mobility model
     // tailored to NTN scenarios is used (GeocentricConstantPositionMobilityModel)
     // create the tx and rx mobility models, set the positions
@@ -467,8 +446,8 @@
     // End changes with respect to three-gpp-channel-example
 
     // set the beamforming vectors
-    DoBeamforming(rxDev, rxAntenna, txDev);
-    DoBeamforming(txDev, txAntenna, rxDev);
+    DoBeamforming(rxMob, rxAntenna, txMob);
+    DoBeamforming(txMob, txAntenna, rxMob);
 
     // Open the output results file
     resultsFile.open("ntn-snr-trace.txt", std::ios::out);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/model/friis-spectrum-propagation-loss.h ns-3.47/src/spectrum/model/friis-spectrum-propagation-loss.h
--- ns-3.46/src/spectrum/model/friis-spectrum-propagation-loss.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/model/friis-spectrum-propagation-loss.h	2026-02-16 16:08:49.822230800 -0800
@@ -21,9 +21,7 @@
  * @brief Friis spectrum propagation loss model
  *
  * The propagation loss is calculated according to a simplified version of Friis'
- * formula in which antenna gains are unitary:
- *
- * \f$ L = \frac{4 \pi * d * f}{C^2}\f$
+ * formula in which antenna gains are unitary: \f$L = \frac{4 \pi * d * f}{C^2}\f$
  *
  * where C = 3e8 m/s is the light speed in the vacuum. The intended
  * use is to calculate Prx = Ptx * G
